

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#ifndef __ITEMSLIST_H__
#define __ITEMSLIST_H__

#include <stdlib.h>

class List
{
 public:
   inline List (int size=10) 
    {
     currentSize_=0; 
     maxSize_=size; 
// Tutorial info   
// To remove the memory error (ABWL) 
// Go up one level in the call stack
     tab_= (void **)malloc (sizeof(void *) * size);
     index_=0;
    };
   inline ~List ()  
    { 
     free(tab_);
    };
   void addItem(void *item);
   void *getCurrent();
   void goFirst();
   void goLast();
   void goNext();
   void goPrevious();
   int isEmpty() {return(currentSize_==0); };
   int isFirst() {return(index_==0); };
   int isLast() {return(index_==currentSize_-1); }; 

 private:
   int currentSize_;
   int maxSize_;
   int index_;
   void **tab_;
};


#endif
