

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT SystemTest server example
 *
 * file        : api.h
 */

#ifndef __API__
#define __API__
#define ANSI_C

#ifndef EXTERN
#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN extern
#endif
#endif

#define err_ok            0
#define err_empty         1
#define err_closed        2
#define err_again         3
#define err_fatal         4
#define err_stack_local   5
#define err_stack_cnf     6
#define err_connect       7
#define err_already       8
#define err_notinit       9

extern char * err_string[];

/* port number of the SERVER application */
#define SERVER_PORT_NUM 1906


/* C types used for messages */

#define MAX_USERDATA_LENGTH 1500


/* C type used for a buffer */
#define MAX_BUFFER_LENGTH   1500
typedef unsigned char buffer_t[MAX_BUFFER_LENGTH];


/* C type used for application identification */
/* This is the type that can be used for the COMMTYPE */
typedef struct {
 int s_id;
 int init;
} appl_id_t;



/* Create a new socket */
/* Connect it to the Server that listens on SERVER_PORT_NUM */
/* id.s_id stores the new socket id */
EXTERN int api_init(
#ifdef ANSI_C
		 appl_id_t *id,
		 char *server_ip_address
#endif
);


/* Read a message on the socket id.s_id */
EXTERN int api_get_message (
#ifdef ANSI_C
                      appl_id_t  *id, void *message,int maxlen, int timeout
#endif
);



/* Write a message on the socket id.s_id */
EXTERN int api_send_message (
#ifdef ANSI_C
                      appl_id_t *id, const void *message, int len
#endif
);


/* Close the socket id.s_id */
EXTERN int api_end(
#ifdef ANSI_C
                 appl_id_t *id
#endif
);

#endif










