

/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef FILE_H
#define FILE_H

struct ListItem {

   const char *str;
   ListItem *previous;
   ListItem *next;

};

class InvalidOperation {
   public:
      const char *message;
      InvalidOperation (const char *msg) : message (msg) {};
};

class File {

   protected:
      ListItem *first;
      ListItem *last;
      int Counter;
      virtual void removed (ListItem *item);

   public:
      File () : first (0), last (0) {}
      File (const File &);
      virtual ~File ();
      int count () const;
      void insert (const char *str);
      void append (const char *str);
      void clear ();
      const char *popHead ();
      const char *popTail ();

};

#endif
