

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#include <malloc.h>
#include <string.h>

void display(char *s1, char *s2)
{
char s[101];
int x=0;
char *p=s;
char *i=s1;
while (*i && (x++<100)) *p++=*i++;
i=s2;
while(*i && (x++<100)) *p++=*i++;
*p=0;
#pragma attol att_insert _ATT_USER_NOTE(s);
}

void subFree(char *pf)
{
display("Free of ",pf);
free(pf);
}
void subABWL1(char *pa)
{
char *p=pa;
p--;
*p='R';
display("ABWL on head of ",pa);
p++;
}

void subABWL2(char *pa)
{
char *p=pa;
while( *p++);
p+=3;
*p='R';
display("ABWL on tail of ",pa);
p++;
}

void subFMWL(char *pw)
{
pw++;
*pw='T';
pw--;
}

/*
p1 ->FMWL
p2- ->ABWL (on the head)
p3 ->ABWL (on the head) but not tracked using manual track
p4 ->ABWL (on the tail)
p5 ->no corruptions
*/
void TestCalc2 ()
{
 int x,y,z;
  char *p1;
 char *p2;
 char *p3;
 char *p4;
 char *p5;
 p1= strdup("123456789");
 p2=strdup("2345678901234567890");
 p3=strdup("3456789012AZERTYUIOPQSDFGHJKL");
 p4=strdup("4NBVCXWMLKJHGFDSQPOIUYTREZA098765432109");
 p5=strdup("5NOTHING");
#pragma attol insert _ATP_TRACK(p1)
#pragma attol insert _ATP_TRACK(p2)
#pragma attol insert _ATP_TRACK(p4) /* not p3 */
#pragma attol insert _ATP_TRACK(p4)
#pragma attol insert _ATP_TRACK(p5)

subFree(p1);
display("FMWL on ","p1");
subFMWL(p1);

subABWL1(p2);
subABWL1(p3);

/* ABWL detected by _ATP_CHECK */
display("ABWL on tail of ","p2");
x=strlen(p2)+3;
p2[x] = 't';
#pragma attol insert _ATP_CHECK(@RELFLINE)
subABWL2(p4);

#pragma attol insert _ATCPQ_DUMP(1);
subFree(p5);
display("TestCalc2"," ends");
x=0;
}

int main (void)
{
  TestCalc2();
  return (0);
}









