

/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifndef CSV_SEPARATOR
#define CSV_SEPARATOR ','  /* CVS format*/
#endif
#define MAXVARS 20
#define SIZELINE 500
#define MAX_VALUE_INT 0x7FFFFFFF
char atl_novars[]="0";
static int J1;
int atl_J1R;
FILE *atl_fd;
char atl_line1[SIZELINE];
char atl_line2[SIZELINE];
char atl_separator;
char *atl_varNames[MAXVARS];
char *atl_varValues[MAXVARS];
int atl_maxVars;
int atl_loop;

int splitLine(char ** Values, char *line10)
{
int l=0;
int x=0;
	Values[x++]=line10;
	while((l<SIZELINE) && (x<MAXVARS) && (line10[l]!='\n') && (line10[l]!='\r') && (line10[l]!=0))
	{
		if(line10[l]==atl_separator)
		{
			line10[l++]=0;
			Values[x++]=&line10[l];
		}
		else
		{
			l++;
		}
	}
	line10[l]=0;
return (x);
}

int dataInLineSetUp(char *filename,char sep,int flag)
{
int nb=0;
	if ((sep< ' ') || (sep >'\0177'))
		atl_separator=CSV_SEPARATOR;
	else
		atl_separator=sep;
	if((atl_fd=fopen(filename,"r"))==NULL)
	{
	    printf("%s file not found\n",filename);
		return (0);
	}
	fgets(atl_line1,SIZELINE,atl_fd);
	atl_maxVars=splitLine(atl_varNames,atl_line1);

	atl_J1R=MAX_VALUE_INT;
	atl_loop=MAX_VALUE_INT;
	if(flag)
	{
		/* count the number on line in the file */
		/* skip the second line (not used one) */
		fgets(atl_line2,SIZELINE,atl_fd);
		while(fgets(atl_line2,SIZELINE,atl_fd)!=NULL) nb++;
		fclose(atl_fd);
		atl_fd=fopen(filename,"r");
		fgets(atl_line2,SIZELINE,atl_fd);
		atl_loop=nb;
	}
	/* skip the second line (not used one) */
	fgets(atl_line2,SIZELINE,atl_fd);
	return (atl_loop);
}


char * readVar(char * varName)
{
int y=0;
	while((y<atl_maxVars) && (strcmp(varName,atl_varNames[y])!=0)) y++;
	if(y==atl_maxVars) return atl_novars;
	if(atl_J1R!=J1)
	{
		/* read the next line */
		if(fgets(atl_line2,SIZELINE,atl_fd)==NULL)
		{
			fclose(atl_fd);
			J1=MAX_VALUE_INT;
			printf("end of file found\n");
			return(atl_novars);
		}
		splitLine(atl_varValues,atl_line2);
		atl_J1R=J1;
		if(J1==atl_loop)
			fclose(atl_fd);
	}
	return (atl_varValues[y]);
}

char * readVarf(char * varName)
{
char *r=readVar(varName);
char *s=r;
if(atl_separator != ',')
	while (*s)
	{
		if(*s==',')
		  {
			*s='.';
			break;
		  }
		s++;
	}
return (r);
}

/* VAR myvar.myFieldArrayOfDouble, init=atod(readArrayf("INIT_FieldArrayOfDouble",I)), ev==atod(readArrayf("EV_FieldArrayOfDouble",I))
data file is then
INIT_FieldArrayOfDouble,   ,   ,   ,   ,EV_FieldArrayOfDouble,   ,   ,   ,
                    5.3,5.8,1.7,2.7,9.2,5.4,5.9,1.8,2.8,9.3
*/
char * readArray(char * varName,int I)
{
int y=0;
	while((y<atl_maxVars) && (strcmp(varName,atl_varNames[y])!=0)) y++;
	if(y==atl_maxVars) return atl_novars;
	if(atl_J1R!=J1)
	{
		/* read the next line */
		if(fgets(atl_line2,SIZELINE,atl_fd)==NULL)
		{
			fclose(atl_fd);
			J1=MAX_VALUE_INT;
			printf("end of file found\n");
			return(atl_novars);
		}
		splitLine(atl_varValues,atl_line2);
		atl_J1R=J1;
		if(J1==atl_loop)
			fclose(atl_fd);
	}
	return (atl_varValues[y+I]);
}

char * readArrayf(char * varName,int I)
{
char *r=readArray(varName,I);
char *s=r;
if(atl_separator != ',')
	while (*s)
	{
		if(*s==',')
		  {
			*s='.';
			break;
		  }
		s++;
	}
return (r);
}

/*
int J1;
void main()
{
	int i;
	i=dataInLineSetUp("filtre2.csv",1);
	for (J1=0 ; J1<i; J1++)
	{
		printf("X=%s Y=%s\n",readVar("V1"),readVar("V2"));
	}
}
*/



