
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


-- generic package sample
-- generic package without type parameter
-- contains a subset of common types and variables of each type
generic
 type T is (<>);
 package pkggen is
 x:constant:=8;

-- simple types
  package inclu is
  type G_der_t is new T;
  end;
  type G_enum is (blue ,white,green, red);
  type G_int is range -x.. x;
  type G_mod is mod x;

  type G_real is digits 8 range -1.0*x.. 1.0*x;
  type G_FixedPoint is delta 0.01 range -1.0*x.. 1.0*x;
  type G_DecimalType is delta 0.01 digits 14;

-- record types
  type G_record is record
       a:inclu.G_der_t :=inclu.G_der_t'first;
       b: G_FixedPoint;
     end record;
  type G_array is array(G_enum,G_mod) of G_DecimalType;

-- record type with discriminant and a variant part
  type G_discr(a:G_enum:=G_enum'first) is record
    case a is 
      when G_enum'first=> b:G_int;
      when G_enum'last=>c:G_mod;
      when others => d:G_real;
    end case;
  end record;

  type G_access is access all G_record;
  type G_derived is new G_record;

-- declaration of a variable of each type
-- declaration done using aliased to be able to work with pointers
AG_enum : aliased G_enum;
AG_int : aliased G_int;
AG_mod : aliased G_mod;
AG_real : aliased G_real;
AG_FixedPoint : aliased G_FixedPoint;
AG_DecimalType : aliased G_DecimalType;
AG_record : aliased G_record;
AG_array : aliased G_array;
AG_discr : aliased G_discr;
AG_access : aliased G_access;
AG_derived : aliased G_derived;
AGP_param : aliased T;

-- prototype of a simple (dummy) function
function getinstance return integer;

end;


