
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


---------------------------------------------------------------------
--                      PACKAGE HISTO SPECIFICATIONS               --
---------------------------------------------------------------------

package histo is

subtype T_Pixel is Integer range 0 .. 255 ;             -- grey level from 0 to 255
type T_Bitmap is array (1..200,1..200) of T_Pixel;     -- type bitmap 200 x 200
type T_Histo is array (t_pixel) of Integer;            -- type histogram

type T_Min_Max is record
   min, max : T_Pixel;
end record;

type t_desc is record                                   -- type descriptor :
   histogram : t_histo;                                 --   - histogram
   extreme   : t_min_max;                               --   - min and max
   average   : float;                                   --   - average
end record;

bitmap      : T_Bitmap := (others =>(others =>0));      -- curent bitmap
desc        : t_desc;                                   -- descripteur
message     : string(1..20);                            -- error message
Overflow    : exception;                                -- error if outside bitmap limits

-- histogram calculation beetween (x1,y1) and (x2,y2) points
procedure evaluate_histo(x1,y1,x2,y2:in integer;desc: out t_desc);

end histo;


