

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#if defined(_WIN32) || defined(__GNUC__)
	#include <iostream>
	using namespace std ;
#else
	#include <iostream.h>
#endif
#include "ElementaryShapes.h"

using namespace ElementaryShape;



//--------------------------------
//	Ligne
//--------------------------------
void ElementaryShape::Line::translate( int dx, int dy)
{
	theEnd.translate(dx,dy);
}

void ElementaryShape::Line::translate (const Point& p)
{
	theEnd.translate(p);
}

void ElementaryShape::Line::print()	const
{	 
	cout << "Line from: ";
	getOrigin().print();
	cout << " to: ";
	theEnd.print();
}

int ElementaryShape::Line::isLengthNil() const 
{ 
   return ((theEnd.getX()==getOrigin().getX()) && (theEnd.getY() ==getOrigin().getY())) ;
}

void ElementaryShape::Line::computePerimeter() 
{
   thePerimeter = sqrt( pow((double)theEnd.getX() - getOrigin().getX(),2) +
 		        pow((double)theEnd.getY()- getOrigin().getY(),2) ) ; 
}

const Point ElementaryShape::Line::getFinalPoint() const  
{
	return theEnd ;
}


//--------------------------------
//	Cercle
//--------------------------------
void ElementaryShape::Circle::print()	const
{
	cout << "Circle: ";
	getOrigin().print();
	cout << " radius : " << theRadius;
}

void  ElementaryShape::Circle::setRadius(const int r) 
{
  if (r==0)  
   {
       throw BadParameter() ;
    }
    else
	{
         thePerimeter =NOT_CALCULATED ; 
         //in order to generate a fault in statechart
         theRadius=r ;
	 }
}

int ElementaryShape::Circle::getRadius() 
{
  return theRadius ;
}

void ElementaryShape::Circle::computePerimeter() 
{ 
  thePerimeter = 3.14 *theRadius ;
}


//---------------------------------
//	Rectangle
//--------------------------------
void ElementaryShape::Rectangle::print()	const
{
	cout << "Rectangle at: ";
	getOrigin().print();
	cout << " dimension : " << theLength << " x " << theWidth;
}

void ElementaryShape::Rectangle::computePerimeter() 
{ 
  thePerimeter = (2*theLength) +(2*theWidth) ;
}
void ElementaryShape::Rectangle::setLength(int pLength) 
{
  theLength = pLength ;
  resetPerimeter() ;
}
void ElementaryShape::Rectangle::setWidth(int pWidth) 
{
  theWidth = pWidth ;
  resetPerimeter() ;
}	

//--------------------------------
//	Carre
//--------------------------------
void ElementaryShape::Square::print()	const
{
	cout << "Carre at: ";
	getOrigin().print();
	cout << " side: " << theLength ;
}

void ElementaryShape::Square::setSideLength(int pLength) 
{
  theLength=pLength ;
  theWidth=pLength ;
  resetPerimeter() ; 
}

