

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#include "Shape.h"
#include <math.h>


#ifndef ELEMENTARY_SHAPES_H
#define ELEMENTARY_SHAPES_H
namespace ElementaryShape {
	
//---------------------------------
//Line
//---------------------------------
class Line : public Shape  
{
        private :
                Point   theEnd;

        public :
                Line( const Point& a, const Point& b)
                                        : Shape(a), theEnd(b) {}
                void    print() const ;
                int isLengthNil() const ;
                void    translate ( int dx, int dy);
                void    translate (const Point&);
                const Point getFinalPoint() const;

        protected :
          void computePerimeter() ;
};
//-------------------------------------
//Circle
//-------------------------------------

class   Circle : public Shape 
{
        private :
                int     theRadius;

        public :
                Circle( const Point& c, int r) 
                                        : Shape(c), theRadius(r) { }
                void    print() const;
                void  setRadius(const int r) ; 
                int getRadius() ;


        protected :
          void computePerimeter() ;
};
//------------------------------------- 
//Rectangle
//-------------------------------------
class   Rectangle : public Shape 
{
        protected :
                int     theLength, theWidth;
                void computePerimeter(); 

        public :
                Rectangle( const Point& c, int le, int wi)
                             : Shape(c), theLength(le), theWidth(wi) {}
                void print() const;
                void setLength(int pLength); 
                void setWidth(int pWidth) ;
};
//--------------------------------------------
//Square
//--------------------------------------------

class   Square : public Rectangle 
{
        public :
                Square(const Point& c, int side) 
                                        : Rectangle(c, side, side) { }
                void    print() const;
                void setSideLength(int pLength); 
                
};

}

#endif //ELEMENTARY_SHAPE_H

