

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


//////////////////////////////////////////////////////////////////////
// Point.h: interface for the Point class.
//////////////////////////////////////////////////////////////////////



#ifndef POINT_H
#define POINT_H

//----------------------------------
//class Point  
// this class describes a point in a bi-dimensional world with two axis
// (X-axis or abscissa, and Y-axis or ordinate)
// The  translater method  allows the point to be translated to another point.
//
//The print method is dedicated to display information about the point
//on standard out.
//
//----------------------------------

class Point
{
    public :
        Point(int a = 0, int b = 0)     : x(a), y(b)    { }

        int     getX() const;
        int     getY() const;
        void translate(int dx, int dy);
        void translate(const Point& p);
        void print() const ;

    private :
        int     x,y;
};

#endif //POINT_H


