

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


// Shape.cpp: implementation of the Forme class.
//
//////////////////////////////////////////////////////////////////////

#include "Shape.h"

 const signed Shape::OBSOLETE = -2 ;
 const signed Shape::NOT_CALCULATED =-1 ;

//--------------------------------


void	Shape::translate(int dx, int dy)
	{
	  theOrg.translate(dx,dy); 
	  translate(dx,dy); 
	}

void	Shape::translate (const Point& p)
	{ 
	  theOrg.translate(p); 
	  translate(p); 
	}
	
void Shape::resetPerimeter() 
          { 
	    thePerimeter = OBSOLETE;
	  }

double Shape::getPerimeter () 
	{
 	  computePerimeter();
	  return thePerimeter ; 
	}

Point	Shape::getOrigin() const
	{ 
	  return theOrg; 
	}

