

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


// alstom2.cpp : Defines the entry point for the console application.
//
// This program is designed to use the Shape and ElementaryShape objects.
// nevertheless, we can use it with the instrumented source code of Shape of ElementaryShape classes  in order to test the Assertion 
// defined in the 'otc' files.
//
#if defined(_WIN32) || defined(__GNUC__)
	#include <iostream>
	using namespace std ;
#else
	#include <iostream.h>
#endif
//#include "StdAfx.h"
#include "Shape.h"
#include "Point.h"
#include "ElementaryShapes.h"
#include "ShapeQueue.h"
#include "ShapeGathering.h"



int main(int argc, char* argv[])
{

   // object declaration
   Point aCenter(0,0), aA(5,5), aB(10,10), aC(50,50) ;
   ElementaryShape::Rectangle aRec1(aA,10,20);
   ElementaryShape::Rectangle aRec2(aB,20,30);
   ElementaryShape::Square  aSqr1(aB,15), aSqr2(aC,12) ; 
   ElementaryShape::Circle  aCir1(aC,5), aCirc2(aC,12) ;
   ShapeQueue aSQ ;

   //get perimeter
   aSqr1.getPerimeter() ;
   aRec1.getPerimeter() ;

   // can be use for assertion test
   aCir1.setRadius(10);
   	cout << "perimeter:  " << aCir1.getPerimeter() ;
        cout << "\n" ;
   aSqr1.setSideLength(0) ;
   aRec1.setLength(0);
   aRec1.setWidth(0);

   //get perimeter
   aSqr1.getPerimeter() ;
   aRec1.getPerimeter() ;


  #pragma attol att_insert  _ATT_USER_NOTE("FILL THE QUEUE")

   // fill the ShapeQueue 
   // useful for Tracer.

	aSQ.append(aRec1);
	aSQ.append(aSqr1);
	aSQ.append(aCirc2);
	aSQ.append(aRec2);

	//retrieve the last element of the queue
	Shape &anElt = aSQ.popTail() ;

	//print the umber of elements in in the queue
	cout << "number of elements: " << aSQ.count() << "\n";
	//print the perimeter of the first and last element of the queue
	cout << "perimeter of first element: " << (aSQ.popHead()).getPerimeter() << "\n" ; 
	cout << "perimeter of the last element: " <<  anElt.getPerimeter()<< "\n" ;


	// print the shape
	(aSQ.popHead()).print() ;
        cout << "\n" ;
	anElt.print() ;
        cout << "\n" ;

    //to raise an exception
    try 
	{
	  aCir1.setRadius(0);
	} catch(BadParameter) { cout << "catch de l'exception \n" ;}

	return 0;
}  // end main


