

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


////////////////////////////////////////
// Class Queue: specificaton
////////////////////////////////////////

#ifndef QUEUE_H
#define QUEUE_H

template<class Info>
struct ListItem {

   Info *clas;
   ListItem<Info> *previous;
   ListItem<Info> *next;

};

class InvalidOperation {
   public:
      const char *message;
      InvalidOperation (const char *msg) : message (msg) {};
};

template<class Info>
class Queue {

   protected:
      ListItem<Info> *first;
      ListItem<Info> *last;
      virtual void removed (ListItem<Info> *item);

   public:
      Queue () 
          {
                first = 0;
                last = 0;
      }
      virtual ~Queue ();
      int count ();
      void insert (Info &cls);
      void append (Info &cls);
      void clear ();
      Info &popHead ();
      Info &popTail ();

};

extern const char *EMPTY_LIST;



#endif //QUEUE_H

