
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2004 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------




With Ada.Numerics.Generic_Elementary_Functions;
With Ada.Numerics; Use Ada.numerics;

Package Body Forms Is

   Package Calc Is New Ada.Numerics.Generic_Elementary_Functions(Float);
   Use Calc;
  Function Area(C : In Point) Return Float Is
  Begin
    Return(1.0);
  end Area;

   Function Area(C : In Circle) Return Float Is
   Begin
     Return Pi*(C.Radius**2);
   End Area;

   Function Perimeter(C : In Circle) Return Float Is
   Begin
     Return 2.0*Pi*C.Radius;
   End Perimeter;

   Function Area(T : In Triangle) Return Float Is
     S : Constant Float := 0.5 * (T.A + T.B + T.C);
   Begin
     Return Sqrt(S * (S - T.A) * (S - T.B) * (S - T.C));
   End Area;
  
   Function Area(C : In Cylinder) Return Float Is
   Begin
     Return 2.0*Area(Circle(C))+(C.Height*Perimeter(Circle(C)));
   End Area;
      
   Function Volume(C : In Cylinder) Return Float Is
   Begin
     Return Area(Circle(C))*C.Height;
   End Volume;

End Forms;

