/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifdef _WIN32
#include <windows.h>
#include <stdio.h>
typedef VOID (*MYPROC)(LPTSTR,int);
#else
#include <stdio.h>
#include <dlfcn.h>
#define BOOL int
#define FALSE 0
#define TRUE 1
typedef void (*ProcAdd_t)(char*,int);
#endif


void printFRes(BOOL r)
{
	printf("FreeLibrary result=%d\n",r);
}

void printLRes(BOOL r)
{
	printf("LoadLibrary result=%d\n",r);
}

#ifdef _WIN32
int main()
{
    MYPROC ProcAdd;
	BOOL res;
    BOOL fFreeResult, fRunTimeLinkSuccess = FALSE;

    printf("main\n");

	HMODULE myDll=LoadLibrary(
	  "mySharedLib.dll"   // file name of module
	);
	printLRes(res=(myDll!=NULL));
    if (res)
    {
	    Sleep(1000);
        ProcAdd = (MYPROC) GetProcAddress(myDll, "DllPrint");

        // If the function address is valid, call the function.

        if (fRunTimeLinkSuccess = (ProcAdd != NULL))
            (ProcAdd) ("message via DLL function",1);

        // Free the DLL module.

        fFreeResult = FreeLibrary(myDll);
	    printFRes(res);
    }



	myDll=LoadLibrary(
	  "myDll2.dll"   // file name of module
	);
	printLRes(res=(myDll!=NULL));
    if (res)
    {
	    Sleep(1000);
        ProcAdd = (MYPROC) GetProcAddress(myDll, "DllPrint");

        // If the function address is valid, call the function.

        if (fRunTimeLinkSuccess = (ProcAdd != NULL))
            (ProcAdd) ("message via other DLL function",2);

        // Free the DLL module.

        fFreeResult = FreeLibrary(myDll);
	    printFRes(res);
    }
    if(res)
		Sleep(1000);

	exit(0);
	return 0;
}

#else

int main()
{
    void * myDll;
    ProcAdd_t ProcAdd;
    int res;
    int FreeResult, fRunTimeLinkSuccess = FALSE;

    printf("main\n");

    myDll = dlopen("mySharedLib.so", RTLD_NOW);

	printLRes(res=(myDll!=NULL));
    if (res)
    {
		ProcAdd = (ProcAdd_t)dlsym(myDll, "DllPrint");

        if (fRunTimeLinkSuccess = (ProcAdd != NULL))
		/* (*ProcAdd)(); */
            (ProcAdd) ("message via other DLL function",1);
		else
		{
			printf("%s\n", dlerror());
		}

		FreeResult = dlclose(myDll);
    	printFRes(res=(FreeResult==0));
    }
    else
    {
        printf("%s\n", dlerror());
    }


    myDll = dlopen("myDll2.so", RTLD_NOW);
	printLRes(res=(myDll!=NULL));
    if (res)
    {
		ProcAdd = (ProcAdd_t)dlsym(myDll, "DllPrint");

        if (fRunTimeLinkSuccess = (ProcAdd != NULL))
		/* (*ProcAdd)(); */
            (ProcAdd) ("message via other DLL function",2);
		else
		{
			printf("%s\n", dlerror());
		}

		FreeResult = dlclose(myDll);
    	printFRes(res=(FreeResult==0));
    }
    else
    {
        printf("%s\n", dlerror());
    }
    return 0;
}
#endif
