/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifdef _WIN32
#include <windows.h>
#define EXPORT_FCT __declspec(dllexport)
#endif
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <malloc.h>

static int nbProcess=0;
static int nbThread=0;

#include "myDll.h"

void DllPrint(char * msg,int v)
{
	int l=100;
#pragma attol atp_insert l=30; // generate an ABWL when instrumented
	char *s=(char *)malloc(l);
//	char *s=new char[l];
	sprintf(s,"DLL2:%s %d\n",msg,v);
	printf(s);
}

#ifdef _WIN32
BOOL APIENTRY DllMain(HANDLE hModule,
                      DWORD  ul_reason_for_call,
                      LPVOID lpReserved)
{
    switch( ul_reason_for_call ) {
    case DLL_PROCESS_ATTACH:
		nbProcess++;
		break;
    case DLL_THREAD_ATTACH:
    	nbThread++;
		break;
    case DLL_THREAD_DETACH:
    	nbThread--;
		break;
    case DLL_PROCESS_DETACH:
    	nbProcess--;
#pragma attol att_insert _ATT_USER_NOTE("removing DLL2")
#pragma attol insert if(!nbProcess) {printf("DLL2:RTRT dump\n"); _ATCPQ_DUMP(1); printf("DLL2:RTRT remove\n");_REMOVE_DYNAMIC_LIB();}
    }
    DllPrint("Attached Processes:",nbProcess);
    DllPrint("Attached Threads:",nbThread);
    return TRUE;
}

#else
int _fini()
{
	printf("Inside mydll2.so: _fini()\n");
   #pragma attol att_insert _ATT_USER_NOTE("removing DLL2")
   #pragma attol insert _ATCPQ_DUMP(1);
   #pragma attol insert _REMOVE_DYNAMIC_LIB()
	return 0;
}

#endif
