

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include "file.h"

#ifndef ONLY_TEMPLATE_BODIES
const char *EMPTY_LIST = "The operation is not possible : The list is empty";
#endif

template <class Info>
File<Info>::~File ()
{
   clear ();
}

template<class Info>
void File<Info>::removed (ListItem<Info> *item)
{
}

template<class Info>
int File<Info>::count ()
{
   int result = 0;
   ListItem<Info> *it = first;

   while (it != 0)
   {
      result++;
      it = it->next;
   }

   return result;
}

template<class Info>
void File<Info>::insert (Info &str)
{
   ListItem<Info> *item = new ListItem<Info>;

   item->clas = &str;
   item->previous = 0;
   item->next = first;
   if (last == 0) last = item;
   else first->previous = item;
   first = item;
}

template<class Info>
void File<Info>::append (Info &str)
{
   ListItem<Info> *item = new ListItem<Info>;

   item->clas = &str;
   item->next = 0;
   item->previous = last;
   if (first == 0) first = item;
   else last->next = item;
   last = item;
}

template<class Info>
Info &File<Info>::popHead ()
{
   if (first == 0) throw InvalidOperation (EMPTY_LIST);

   Info *result = first->clas;
   ListItem<Info> *it = first;

   removed (first);
   first = first->next;
   delete it;
   if (first == 0) last = 0;
   else first->previous = 0;
   return *result;
}

template<class Info>
Info &File<Info>::popTail ()
{
  if (first == 0) throw InvalidOperation (EMPTY_LIST);

   Info *result = last->clas;
   ListItem<Info> *it = last;

   removed (last);
   last = last->previous;
   delete it;
   if (last == 0) first = 0;
   else last->next = 0;
   return *result;
}

template<class Info>
void File<Info>::clear ()
{
   ListItem<Info> *it;
   while (first != 0)
   {
      removed (first);
      it = first;
      first = first->next;
      delete it;
   }
   last = 0;
}

template class File<char*>;



