
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------



package body CodeCoverage is

-- Global variable
selectCase: Types.Switch_t;
Global_Detect_While: natural;
Table: Types.Table_T;

procedure TEST is separate;

function SimpleCondition(x: in integer) return integer is
begin
	if (x<0) then
		return (-x);
	else
		return (x);
	end if;
end SimpleCondition;

procedure call is
x: integer:=1;
begin
	x:=SimpleCondition(x);
end call;

function SimpleConditionWithImplicit(x: in integer) return integer is
begin
	if (x<0) then
		return (-x);
	end if;
	return (x);
end SimpleConditionWithImplicit;

function AndCondition(x: in integer) return integer is
begin
	if ((x>0) and (x<100)) then
		return (x);
	else
		return 0;
	end if;
end AndCondition;

function OrCondition(x: in integer) return integer is
begin
	if ((x=1) or (x>10)) then
		return (x);
	else
		return 0;
	end if;
end OrCondition;

function Sum(x: in integer) return natural is
sumValue: natural := 0;
begin
	for idx in reverse 0..(x-1) loop
		sumValue:=sumValue+(x-idx);
	end loop;
	return (sumValue);
end Sum;

function CheckCoverageStatement(cond1, cond2, cond3, cond4, cond5: in boolean) return float is
retValue: float:=0.0;
Index: natural:=0;
begin
	-- Code to test instrumentation of if instruction and implicit else
	if (cond1=true) then
		retValue:=1.0;
	end if;

	-- Code to test instrumentation of case instruction and implicit default
	case selectCase is
		when Types.CASE_1 => Detect_switch_case:=set_switch(1);
		when Types.CASE_2 => Detect_switch_case:=set_switch(2);
		when Types.CASE_3 => Detect_switch_case:=set_switch(3);
		when others => Detect_switch_case:=set_switch(4);
	end case;

	-- Code to test instrumentation of MCDC
	if (((cond1 and cond2) or (cond3 and cond4)) and cond5) then
		retValue:=2.0;
	end if;

	-- Code to test instrumentation of while instruction
	while (Global_Detect_While/=0) loop
		Global_Detect_While:=Global_Detect_While-1;
	end loop;

	-- Code to test instrumentation of for instruction
	for Index in 1..Max_Index loop
		Table(Index):=Index;
	end loop;

	return (retValue);

end CheckCoverageStatement;

end CodeCoverage;

