/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/* TestSuiteC - Memory Profiling example for FIM */
#define trace printf
#ifndef trace
#define trace // //no trace
#endif
#define ALLOC(s) malloc(s)
#define REALLOC(p,s) realloc(p,s)
#define FREE(p) free(p)

#ifdef _WIN32
#include <windows.h>
#else
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#endif

void nofim()
{
	int *x0 = (int*)ALLOC(20);
	FREE( x0 );

	int* x1 = new int(5);
	delete x1;

	char* x2 = new char[20];
	delete [] x2;

}

void fim01()
{
	int *x01 = (int*)ALLOC(20);
	delete x01;
}

void fim02()
{
	int *x02 = (int*)ALLOC(20);
	delete[] x02;
}

void fim21()
{
	char *x21 = new char [25];
	delete x21;
}

void fim12()
{
	int *x12 = new int(20);
	delete [] x12;
}

void fim10()
{
	int *x10 = new int(20);
	FREE (x10);
}

void fim20()
{
	char *x20 = new char[22];
	FREE (x20);
}

void fimrealloc()
{
	int* x1 = new int(5);
	x1 = (int *)REALLOC(x1,20);
	delete x1;

	int* x10 = new int(5);
	x10 = (int *)REALLOC(x10,20);
	FREE( x10);

	char* x2 = new char[20];
	x2 = (char *)REALLOC(x2,10);
	delete [] x2;

}

int main()
{
nofim();
fim01();
fim02();
fim10();
fim12();
fim20();
fim21();
fimrealloc();
exit(0);
return 0;
}

