

/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
Here is a simple source file which is used by the TDP team in order to run a benchmark for the performance profiling feature.
This simple files allows you to check:
* TDP time measurement accuracy (Function time and Function+Descendant time)
* Overhead due to a call to an empty function

* TestSuiteC - Performance Profiling example
*/

#define RTRT_LONGJMP  /* undefine RTRT_LONGJMP if longjump is not available in this TDP */

#include <stdio.h>
#include <stdlib.h>

#ifdef RTRT_LONGJMP
#include <setjmp.h>
#endif

#ifdef _WIN32
#include <windows.h>
#endif

const int max=1000;

int idx,idx2;
int divi;
#ifdef RTRT_LONGJMP
jmp_buf mark;              /* Address for long jump to jump to */
#endif

void D1()
{
 for (idx=1; idx<max; idx++) divi=9997/idx;
}

void D2_10Times_D1()
{
 for (idx2=0; idx2<10; idx2++)
    for (idx=1; idx<max; idx++) divi=9997/idx;
}

void D1_plus_D2_plus_D4()
{
/* make 2 calls as D4 */
 D1();
 D2_10Times_D1();
}

void D3_is_empty()
{
 /* empty function */
}

void D0_is_empty()
{
 /* empty function */
}

void D4_2call_D3()
{
/* D4 make 2 calls to empty function */
 D3_is_empty();
 D3_is_empty();
}

special()
{
#ifdef RTRT_LONGJMP
#pragma attol att_insert _ATT_USER_NOTE("longjmp")
 longjmp( mark, -1 );
#endif

}

static unsigned int l[]={12345,54784,27954,21437,58567,6843,25369,7431,38798,24180,32609,938,44529,58242,9847,15398,60};
void minMaxTime(int k)
{
	while (k--);
}
void minMaxTimeL(int i)
{
while(i--)
  {
     minMaxTime(l[i]);
  }
}

int main()
{
 int idx;
 D0_is_empty();
 D4_2call_D3();
 D1_plus_D2_plus_D4();
/* min max */
for(idx=10;idx;idx--) minMaxTimeL(idx);

/*#pragma attol insert _ATCPQ_DUMP(1);*/

#ifdef RTRT_LONGJMP
#pragma attol att_insert _ATT_USER_NOTE("setjmp")
 if(setjmp( mark ) ==0)
#endif
 special();
 return(0);
}



