/*
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



/* TestSuiteC - NbDigits example */

#include <math.h>
#include <float.h>

#define PRINT /* comment this line to disable printf lines */
#ifdef PRINT
#include <stdio.h>
#endif

#define type float
#define typename "float"

void cfloat(type *pNaN,type *pINF, type *pINFn)
{
typedef union CONV {
	type f;
	unsigned char dmp[sizeof(type)];
	} t_conv;
  t_conv v1,v2,v3;
  int i;
  v1.f=10.0;
  v2.f=100.0;
  while ( memcmp (&v1,&v2,sizeof(t_conv)))
    {
      v1.f=v2.f;
      v2.f = v2.f * v2.f;
    }
#ifdef PRINT
  printf(typename);
  printf("  inf : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v2.dmp[i]);
    }
  printf("    %f \n",v2.f);
#endif
 *pINF=v2.f;

  v3.f=v2.f;
  v1.f=-10.0;
  v2.f=-100.0;
  while ( memcmp (&v1,&v2,sizeof(t_conv)))
    {
      v1.f=v2.f;
      v2.f = v2.f * 100.0;
    }
#ifdef PRINT
  printf(typename);
  printf(" -inf : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v2.dmp[i]);
    }
  printf("    %f \n",v2.f);
#endif
 *pINFn=v2.f;

  v3.f/= v2.f;
#ifdef PRINT
  printf(typename);
  printf("  nan : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v3.dmp[i]);
    }
  printf("    %f \n",v3.f);
#endif
 *pNaN=v3.f;
}

#undef typename
#undef type
#define type double
#define typename "double"

void cdouble(type *pNaN,type *pINF, type *pINFn)
{
typedef union CONV {
	type f;
	unsigned char dmp[sizeof(type)];
	} t_conv;
  t_conv v1,v2,v3;
  int i;
  v1.f=10.0;
  v2.f=100.0;
  while ( memcmp (&v1,&v2,sizeof(t_conv)))
    {
      v1.f=v2.f;
      v2.f = v2.f * v2.f;
    }
#ifdef PRINT
  printf(typename);
  printf("  inf : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v2.dmp[i]);
    }
  printf("    %f \n",v2.f);
#endif
 *pINF=v2.f;

  v3.f=v2.f;
  v1.f=-10.0;
  v2.f=-100.0;
  while ( memcmp (&v1,&v2,sizeof(t_conv)))
    {
      v1.f=v2.f;
      v2.f = v2.f * 100.0;
    }
#ifdef PRINT
  printf(typename);
  printf(" -inf : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v2.dmp[i]);
    }
  printf("    %f \n",v2.f);
#endif
 *pINFn=v2.f;

  v3.f/= v2.f;
#ifdef PRINT
  printf(typename);
  printf("  nan : ");
  for (i=0;i<sizeof(type);++i)
    {
      printf("%02x",v3.dmp[i]);
    }
  printf("    %f \n",v3.f);
#endif
 *pNaN=v3.f;
}

#undef typename
#undef type

